Last Comment Bug 1255955 - Wrong element is clicked when requested element is out of view in <select> element
: Wrong element is clicked when requested element is out of view in <select> el...
Status: RESOLVED FIXED
: ateam-marionette-server
Product: Testing
Classification: Components
Component: General (show other bugs)
: Trunk
: All All
-- normal (vote)
: mozilla51
Assigned To: Andreas Tolfsen
:
:
Mentors:
: 1255957 1293622 1314671 (view as bug list)
Depends on:
Blocks: webdriver
  Show dependency treegraph
 
Reported: 2016-03-11 19:24 PST by Titus Fortner
Modified: 2016-11-07 07:13 PST (History)
5 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
fixed
fixed
fixed

MozReview Requests
Submitter Diff Changes Open Issues Last Updated
Loading...
Error loading review requests:
Show discarded requests

Attachments
multiple select list and browse button (86.13 KB, image/png)
2016-03-11 19:24 PST, Titus Fortner
no flags Details
Bug 1255955 - Rename checkbox test to not conflict with select tests; (58 bytes, text/x-review-board-request)
2016-08-05 10:23 PDT, Andreas Tolfsen
dburns: review+
Details | Review
Bug 1255955 - Scroll element into view when not visible; (58 bytes, text/x-review-board-request)
2016-08-05 10:23 PDT, Andreas Tolfsen
dburns: review+
Details | Review
Bug 1255955 - Recalculate visibility after scrolling; (58 bytes, text/x-review-board-request)
2016-08-05 10:23 PDT, Andreas Tolfsen
dburns: review+
Details | Review
Bug 1255955 - Perform click checks as part of promise; (58 bytes, text/x-review-board-request)
2016-08-05 10:23 PDT, Andreas Tolfsen
dburns: review+
Details | Review
Bug 1255955 - Rename a11y functions check* to assert*; (58 bytes, text/x-review-board-request)
2016-08-05 10:23 PDT, Andreas Tolfsen
dburns: review+
Details | Review
Bug 1255955 - Fix event.parseModifiers_ to not use module argument name; (58 bytes, text/x-review-board-request)
2016-08-05 10:23 PDT, Andreas Tolfsen
dburns: review+
Details | Review
Bug 1255955 - Fix event.sendMouseEvent to work in privileged space; (58 bytes, text/x-review-board-request)
2016-08-05 10:23 PDT, Andreas Tolfsen
dburns: review+
Details | Review
Bug 1255955 - Use correct argument in event.synthesizeMouse; (58 bytes, text/x-review-board-request)
2016-08-05 10:23 PDT, Andreas Tolfsen
dburns: review+
Details | Review
Bug 1255955 - Add function to dispatch events to event library; (58 bytes, text/x-review-board-request)
2016-08-05 10:23 PDT, Andreas Tolfsen
dburns: review+
Details | Review
Bug 1255955 - Add shorthands for generating common DOM events; (58 bytes, text/x-review-board-request)
2016-08-05 10:23 PDT, Andreas Tolfsen
dburns: review+
Details | Review
Bug 1255955 - Add support for interacting with <select> elements; (58 bytes, text/x-review-board-request)
2016-08-05 10:23 PDT, Andreas Tolfsen
dburns: review+
Details | Review
Bug 1255955 - Make interaction.clickElement return a promise; (58 bytes, text/x-review-board-request)
2016-08-09 06:26 PDT, Andreas Tolfsen
dburns: review+
Details | Review
Bug 1255955 - Check for pointer-interactability on click; (58 bytes, text/x-review-board-request)
2016-08-09 06:26 PDT, Andreas Tolfsen
dburns: review+
Details | Review
Bug 1255955 - Document clickElement and calculateCentreCoords; (58 bytes, text/x-review-board-request)
2016-08-13 12:01 PDT, Andreas Tolfsen
dburns: review+
Details | Review
Bug 1255955 - Simplify element.clickElement complexity; (58 bytes, text/x-review-board-request)
2016-08-13 12:01 PDT, Andreas Tolfsen
dburns: review+
Details | Review
Bug 1255955 -Run element enabled check before accessibility checks; (58 bytes, text/x-review-board-request)
2016-08-13 12:01 PDT, Andreas Tolfsen
dburns: review+
Details | Review

Description User image Titus Fortner 2016-03-11 19:24:17 PST
Created attachment 8729775 [details]
multiple select list and browse button

User Agent: Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/48.0.2564.116 Safari/537.36

Steps to reproduce:

This test:
https://github.com/watir/watirspec/blob/master/select_list_spec.rb#L268

with this html:
https://github.com/watir/watirspec/blob/master/html/forms_with_input_elements.html#L48

There are 5 options in the list, but only 4 are displayed. To select 'Sweden' a user needs to scroll to it. Marionette is clicking the element below it.

Debug info:
https://gist.github.com/titusfortner/701d4e84f4b31c73f171


Actual results:

The browse button below the multiple select list was clicked


Expected results:

Sweden should have been selected from the multiple select list
Comment 1 User image Andreas Tolfsen 2016-08-05 10:23:38 PDT
Created attachment 8778356 [details]
Bug 1255955 - Rename checkbox test to not conflict with select tests;

Review commit: https://reviewboard.mozilla.org/r/69666/diff/#index_header
See other reviews: https://reviewboard.mozilla.org/r/69666/
Comment 2 User image Andreas Tolfsen 2016-08-05 10:23:38 PDT
Created attachment 8778357 [details]
Bug 1255955 - Scroll element into view when not visible;

The if-condition in the specification compatible interactability check
for interaction.clickElement is wrong.  It should scroll an element into
view when it is _not_ visible.  If it is visible it does not matter.

Review commit: https://reviewboard.mozilla.org/r/69668/diff/#index_header
See other reviews: https://reviewboard.mozilla.org/r/69668/
Comment 3 User image Andreas Tolfsen 2016-08-05 10:23:38 PDT
Created attachment 8778358 [details]
Bug 1255955 - Recalculate visibility after scrolling;

We want to redo the element interactability calculation after scrolling.
Determining if an element is not visible by the old location would
be wrong.

Review commit: https://reviewboard.mozilla.org/r/69670/diff/#index_header
See other reviews: https://reviewboard.mozilla.org/r/69670/
Comment 4 User image Andreas Tolfsen 2016-08-05 10:23:38 PDT
Created attachment 8778359 [details]
Bug 1255955 - Perform click checks as part of promise;

Some of the element interactability- and visibility checks were previously
done when interaction.clickElement was called, and not as part of the
resolution of the returned promise.  This could have caused a potential
race condition.

Review commit: https://reviewboard.mozilla.org/r/69672/diff/#index_header
See other reviews: https://reviewboard.mozilla.org/r/69672/
Comment 5 User image Andreas Tolfsen 2016-08-05 10:23:38 PDT
Created attachment 8778360 [details]
Bug 1255955 - Rename a11y functions check* to assert*;

"Check" is a fine word but with functions which primary purpose is to
throw an error internally we should use "assert" to make the reprecussions
of using them crystal clear.

Review commit: https://reviewboard.mozilla.org/r/69674/diff/#index_header
See other reviews: https://reviewboard.mozilla.org/r/69674/
Comment 6 User image Andreas Tolfsen 2016-08-05 10:23:38 PDT
Created attachment 8778361 [details]
Bug 1255955 - Fix event.parseModifiers_ to not use module argument name;

Review commit: https://reviewboard.mozilla.org/r/69676/diff/#index_header
See other reviews: https://reviewboard.mozilla.org/r/69676/
Comment 7 User image Andreas Tolfsen 2016-08-05 10:23:38 PDT
Created attachment 8778362 [details]
Bug 1255955 - Fix event.sendMouseEvent to work in privileged space;

Also fixes assumptions about permitted mouse events.

Review commit: https://reviewboard.mozilla.org/r/69678/diff/#index_header
See other reviews: https://reviewboard.mozilla.org/r/69678/
Comment 8 User image Andreas Tolfsen 2016-08-05 10:23:38 PDT
Created attachment 8778363 [details]
Bug 1255955 - Use correct argument in event.synthesizeMouse;

Review commit: https://reviewboard.mozilla.org/r/69680/diff/#index_header
See other reviews: https://reviewboard.mozilla.org/r/69680/
Comment 9 User image Andreas Tolfsen 2016-08-05 10:23:38 PDT
Created attachment 8778364 [details]
Bug 1255955 - Add function to dispatch events to event library;

Review commit: https://reviewboard.mozilla.org/r/69682/diff/#index_header
See other reviews: https://reviewboard.mozilla.org/r/69682/
Comment 10 User image Andreas Tolfsen 2016-08-05 10:23:38 PDT
Created attachment 8778365 [details]
Bug 1255955 - Add shorthands for generating common DOM events;

Review commit: https://reviewboard.mozilla.org/r/69684/diff/#index_header
See other reviews: https://reviewboard.mozilla.org/r/69684/
Comment 11 User image Andreas Tolfsen 2016-08-05 10:23:38 PDT
Created attachment 8778366 [details]
Bug 1255955 - Add support for interacting with <select> elements;

This patch introduces support for clicking on <select> and <select
multiple> elements to Marionette.  As <select> elements, especially
<select multiple>, are operating system level concepts usually implemented
with native widget sets, this patch takes the approach of dispatching
generated events.

Review commit: https://reviewboard.mozilla.org/r/69686/diff/#index_header
See other reviews: https://reviewboard.mozilla.org/r/69686/
Comment 12 User image David Burns :automatedtester 2016-08-05 14:38:17 PDT
Comment on attachment 8778356 [details]
Bug 1255955 - Rename checkbox test to not conflict with select tests;

https://reviewboard.mozilla.org/r/69666/#review66866
Comment 13 User image David Burns :automatedtester 2016-08-05 14:57:56 PDT
https://reviewboard.mozilla.org/r/69668/#review66868

::: testing/marionette/interaction.js:95
(Diff revision 1)
>    let win = getWindow(el);
>  
>    let visible = false;
>    if (specCompat) {
>      visible = element.isInteractable(el);
> -    if (visible) {
> +    if (!visible) {

Looking at isInteractable, it will always return `true`. On https://dxr.mozilla.org/mozilla-central/source/testing/marionette/element.js#912 `isKeyboardInteractable()` always returning `true`. I dont think we are going to enter this conditional as it is.
Comment 14 User image David Burns :automatedtester 2016-08-05 14:58:48 PDT
Comment on attachment 8778357 [details]
Bug 1255955 - Scroll element into view when not visible;

https://reviewboard.mozilla.org/r/69668/#review66870
Comment 15 User image David Burns :automatedtester 2016-08-05 14:59:39 PDT
https://reviewboard.mozilla.org/r/69670/#review66872

::: testing/marionette/interaction.js:98
(Diff revision 1)
>    if (specCompat) {
>      visible = element.isInteractable(el);
>      if (!visible) {
>        el.scrollIntoView(false);
>      }
> +    visible = element.isInteractable(el);

Same issue as described in patch titled `Bug 1255955 - Scroll element into view when not visible; r?automatedtester `
Comment 16 User image David Burns :automatedtester 2016-08-05 15:00:15 PDT
Comment on attachment 8778358 [details]
Bug 1255955 - Recalculate visibility after scrolling;

https://reviewboard.mozilla.org/r/69670/#review66874
Comment 17 User image David Burns :automatedtester 2016-08-05 15:01:36 PDT
Comment on attachment 8778359 [details]
Bug 1255955 - Perform click checks as part of promise;

https://reviewboard.mozilla.org/r/69672/#review66876
Comment 18 User image David Burns :automatedtester 2016-08-05 15:04:30 PDT
Comment on attachment 8778360 [details]
Bug 1255955 - Rename a11y functions check* to assert*;

https://reviewboard.mozilla.org/r/69674/#review66878
Comment 19 User image David Burns :automatedtester 2016-08-05 15:31:12 PDT
Comment on attachment 8778361 [details]
Bug 1255955 - Fix event.parseModifiers_ to not use module argument name;

https://reviewboard.mozilla.org/r/69676/#review66884
Comment 20 User image David Burns :automatedtester 2016-08-05 15:31:57 PDT
Comment on attachment 8778362 [details]
Bug 1255955 - Fix event.sendMouseEvent to work in privileged space;

https://reviewboard.mozilla.org/r/69678/#review66886
Comment 21 User image David Burns :automatedtester 2016-08-05 15:32:37 PDT
Comment on attachment 8778363 [details]
Bug 1255955 - Use correct argument in event.synthesizeMouse;

https://reviewboard.mozilla.org/r/69680/#review66888
Comment 22 User image David Burns :automatedtester 2016-08-05 15:33:17 PDT
Comment on attachment 8778364 [details]
Bug 1255955 - Add function to dispatch events to event library;

https://reviewboard.mozilla.org/r/69682/#review66890
Comment 23 User image David Burns :automatedtester 2016-08-05 15:33:56 PDT
Comment on attachment 8778365 [details]
Bug 1255955 - Add shorthands for generating common DOM events;

https://reviewboard.mozilla.org/r/69684/#review66892
Comment 24 User image David Burns :automatedtester 2016-08-05 15:47:50 PDT
https://reviewboard.mozilla.org/r/69686/#review66902

::: testing/marionette/harness/marionette/tests/unit/test_select.py:29
(Diff revision 1)
> +        self.assertFalse(self.marionette.execute_script(
> +            "return arguments[0].selected", script_args=[option_element], sandbox=None),
> +            "<option> selected attribute not updated")
> +
> +
> +class TestSelect(SelectTestCase):

Can you add a test for `optgroup` as there is one in the selenium test suite for some reason 

```
 <select>
    <optgroup label="Group">
      <option value="one">one</option>
      <option id="two-in-group" value="two">two</option>
    </optgroup>
</select>
```
Comment 25 User image David Burns :automatedtester 2016-08-05 15:48:13 PDT
Comment on attachment 8778366 [details]
Bug 1255955 - Add support for interacting with <select> elements;

https://reviewboard.mozilla.org/r/69686/#review66904
Comment 26 User image Andreas Tolfsen 2016-08-09 05:05:15 PDT
*** Bug 1293622 has been marked as a duplicate of this bug. ***
Comment 27 User image Andreas Tolfsen 2016-08-09 06:21:10 PDT
Comment on attachment 8778357 [details]
Bug 1255955 - Scroll element into view when not visible;

https://reviewboard.mozilla.org/r/69668/#review66868

> Looking at isInteractable, it will always return `true`. On https://dxr.mozilla.org/mozilla-central/source/testing/marionette/element.js#912 `isKeyboardInteractable()` always returning `true`. I dont think we are going to enter this conditional as it is.

You’re right, and according to a spec patch I filed yesterday we should only check for pointer-interactability here: https://github.com/w3c/webdriver/pull/321/files#diff-ce5a67d95770dc70b1b4250c7a9348f2R4138
Comment 28 User image Andreas Tolfsen 2016-08-09 06:26:28 PDT Comment hidden (mozreview-request)
Comment 29 User image Andreas Tolfsen 2016-08-09 06:26:28 PDT Comment hidden (mozreview-request)
Comment 30 User image Andreas Tolfsen 2016-08-09 06:26:28 PDT Comment hidden (mozreview-request)
Comment 31 User image Andreas Tolfsen 2016-08-09 06:26:28 PDT Comment hidden (mozreview-request)
Comment 32 User image Andreas Tolfsen 2016-08-09 06:26:28 PDT Comment hidden (mozreview-request)
Comment 33 User image Andreas Tolfsen 2016-08-09 06:26:28 PDT Comment hidden (mozreview-request)
Comment 34 User image Andreas Tolfsen 2016-08-09 06:26:28 PDT Comment hidden (mozreview-request)
Comment 35 User image Andreas Tolfsen 2016-08-09 06:26:28 PDT
Comment on attachment 8778361 [details]
Bug 1255955 - Fix event.parseModifiers_ to not use module argument name;

Review request updated; see interdiff: https://reviewboard.mozilla.org/r/69676/diff/1-2/
Comment 36 User image Andreas Tolfsen 2016-08-09 06:26:28 PDT Comment hidden (mozreview-request)
Comment 37 User image Andreas Tolfsen 2016-08-09 06:26:28 PDT Comment hidden (mozreview-request)
Comment 38 User image Andreas Tolfsen 2016-08-09 06:26:28 PDT Comment hidden (mozreview-request)
Comment 39 User image Andreas Tolfsen 2016-08-09 06:26:28 PDT Comment hidden (mozreview-request)
Comment 40 User image Andreas Tolfsen 2016-08-09 06:26:28 PDT Comment hidden (mozreview-request)
Comment 41 User image Andreas Tolfsen 2016-08-09 06:27:04 PDT
Comment on attachment 8778366 [details]
Bug 1255955 - Add support for interacting with <select> elements;

https://reviewboard.mozilla.org/r/69686/#review66902

> Can you add a test for `optgroup` as there is one in the selenium test suite for some reason 
> 
> ```
>  <select>
>     <optgroup label="Group">
>       <option value="one">one</option>
>       <option id="two-in-group" value="two">two</option>
>     </optgroup>
> </select>
> ```

Good catch.  Added a test.
Comment 42 User image David Burns :automatedtester 2016-08-09 07:21:58 PDT
Comment on attachment 8778357 [details]
Bug 1255955 - Scroll element into view when not visible;

https://reviewboard.mozilla.org/r/69668/#review67626
Comment 43 User image David Burns :automatedtester 2016-08-09 07:22:37 PDT
Comment on attachment 8778358 [details]
Bug 1255955 - Recalculate visibility after scrolling;

https://reviewboard.mozilla.org/r/69670/#review67630
Comment 44 User image David Burns :automatedtester 2016-08-09 07:23:16 PDT
Comment on attachment 8779328 [details]
Bug 1255955 - Make interaction.clickElement return a promise;

https://reviewboard.mozilla.org/r/70324/#review67636
Comment 45 User image David Burns :automatedtester 2016-08-09 07:23:33 PDT
Comment on attachment 8778358 [details]
Bug 1255955 - Recalculate visibility after scrolling;

https://reviewboard.mozilla.org/r/69670/#review67638
Comment 46 User image David Burns :automatedtester 2016-08-09 07:23:56 PDT
Comment on attachment 8778358 [details]
Bug 1255955 - Recalculate visibility after scrolling;

https://reviewboard.mozilla.org/r/69670/#review67640
Comment 47 User image David Burns :automatedtester 2016-08-09 07:24:25 PDT
Comment on attachment 8779329 [details]
Bug 1255955 - Check for pointer-interactability on click;

https://reviewboard.mozilla.org/r/70326/#review67642
Comment 48 User image Andreas Tolfsen 2016-08-12 08:48:18 PDT Comment hidden (mozreview-request)
Comment 49 User image Andreas Tolfsen 2016-08-12 08:48:18 PDT Comment hidden (mozreview-request)
Comment 50 User image Andreas Tolfsen 2016-08-12 08:48:18 PDT Comment hidden (mozreview-request)
Comment 51 User image Andreas Tolfsen 2016-08-12 08:48:18 PDT Comment hidden (mozreview-request)
Comment 52 User image Andreas Tolfsen 2016-08-12 08:48:18 PDT Comment hidden (mozreview-request)
Comment 53 User image Andreas Tolfsen 2016-08-12 08:48:18 PDT Comment hidden (mozreview-request)
Comment 54 User image Andreas Tolfsen 2016-08-12 08:48:18 PDT Comment hidden (mozreview-request)
Comment 55 User image Andreas Tolfsen 2016-08-12 08:48:18 PDT Comment hidden (mozreview-request)
Comment 56 User image Andreas Tolfsen 2016-08-12 08:48:18 PDT Comment hidden (mozreview-request)
Comment 57 User image Andreas Tolfsen 2016-08-12 08:48:18 PDT Comment hidden (mozreview-request)
Comment 58 User image Andreas Tolfsen 2016-08-12 08:48:18 PDT Comment hidden (mozreview-request)
Comment 59 User image Andreas Tolfsen 2016-08-13 12:01:04 PDT Comment hidden (mozreview-request)
Comment 60 User image Andreas Tolfsen 2016-08-13 12:01:04 PDT Comment hidden (mozreview-request)
Comment 61 User image Andreas Tolfsen 2016-08-13 12:01:04 PDT Comment hidden (mozreview-request)
Comment 62 User image Andreas Tolfsen 2016-08-13 12:01:04 PDT Comment hidden (mozreview-request)
Comment 63 User image Andreas Tolfsen 2016-08-13 12:01:04 PDT Comment hidden (mozreview-request)
Comment 64 User image Andreas Tolfsen 2016-08-13 12:01:04 PDT Comment hidden (mozreview-request)
Comment 65 User image Andreas Tolfsen 2016-08-13 12:01:04 PDT Comment hidden (mozreview-request)
Comment 66 User image Andreas Tolfsen 2016-08-13 12:01:04 PDT Comment hidden (mozreview-request)
Comment 67 User image Andreas Tolfsen 2016-08-13 12:01:04 PDT Comment hidden (mozreview-request)
Comment 68 User image Andreas Tolfsen 2016-08-13 12:01:04 PDT Comment hidden (mozreview-request)
Comment 69 User image Andreas Tolfsen 2016-08-13 12:01:04 PDT Comment hidden (mozreview-request)
Comment 70 User image Andreas Tolfsen 2016-08-13 12:01:04 PDT Comment hidden (mozreview-request)
Comment 71 User image Andreas Tolfsen 2016-08-13 12:01:04 PDT Comment hidden (mozreview-request)
Comment 72 User image Andreas Tolfsen 2016-08-13 12:01:04 PDT Comment hidden (mozreview-request)
Comment 73 User image David Burns :automatedtester 2016-08-16 14:02:46 PDT
Comment on attachment 8780854 [details]
Bug 1255955 - Document clickElement and calculateCentreCoords;

https://reviewboard.mozilla.org/r/71436/#review69568
Comment 74 User image David Burns :automatedtester 2016-08-16 14:03:50 PDT
Comment on attachment 8780855 [details]
Bug 1255955 - Simplify element.clickElement complexity;

https://reviewboard.mozilla.org/r/71438/#review69572
Comment 75 User image David Burns :automatedtester 2016-08-16 14:12:17 PDT
Comment on attachment 8780856 [details]
Bug 1255955 -Run element enabled check before accessibility checks;

https://reviewboard.mozilla.org/r/71440/#review69580
Comment 76 User image Pulsebot 2016-08-17 04:21:23 PDT
Pushed by atolfsen@mozilla.com:
https://hg.mozilla.org/integration/autoland/rev/68a158b365c8
Rename checkbox test to not conflict with select tests; r=automatedtester
https://hg.mozilla.org/integration/autoland/rev/ccb7b3eed99b
Scroll element into view when not visible; r=automatedtester
https://hg.mozilla.org/integration/autoland/rev/b73525918482
Recalculate visibility after scrolling; r=automatedtester
https://hg.mozilla.org/integration/autoland/rev/04e81c5855ce
Perform click checks as part of promise; r=automatedtester
https://hg.mozilla.org/integration/autoland/rev/136dce46f6e3
Rename a11y functions check* to assert*; r=automatedtester
https://hg.mozilla.org/integration/autoland/rev/a7cfbd664c93
Fix event.parseModifiers_ to not use module argument name; r=automatedtester
https://hg.mozilla.org/integration/autoland/rev/1638c7c1614d
Fix event.sendMouseEvent to work in privileged space; r=automatedtester
https://hg.mozilla.org/integration/autoland/rev/b7eed459e6d7
Use correct argument in event.synthesizeMouse; r=automatedtester
https://hg.mozilla.org/integration/autoland/rev/9ed13f873a2a
Add function to dispatch events to event library; r=automatedtester
https://hg.mozilla.org/integration/autoland/rev/8ef4a877d2be
Add shorthands for generating common DOM events; r=automatedtester
https://hg.mozilla.org/integration/autoland/rev/8e8aa1f9c27b
Add support for interacting with <select> elements; r=automatedtester
https://hg.mozilla.org/integration/autoland/rev/8426aadbf3db
Document clickElement and calculateCentreCoords; r=automatedtester
https://hg.mozilla.org/integration/autoland/rev/2b2e61f6c66b
Simplify element.clickElement complexity; r=automatedtester
https://hg.mozilla.org/integration/autoland/rev/da03fe82ba9d
Run element enabled check before accessibility checks; r=automatedtester
Comment 78 User image Andreas Tolfsen 2016-08-19 05:39:33 PDT
These are test-only changes.
Comment 81 User image Andreas Tolfsen 2016-10-12 08:46:13 PDT
*** Bug 1255957 has been marked as a duplicate of this bug. ***
Comment 82 User image Andreas Tolfsen 2016-11-07 07:13:10 PST
*** Bug 1314671 has been marked as a duplicate of this bug. ***

Note You need to log in before you can comment on or make changes to this bug.